--[[-- Copyright (c) 2024 Huawei Technologies Co., Ltd.
-- openUBMC is licensed under Mulan PSL v2.
-- You can use this software according to the terms and conditions of the Mulan PSL v2.
-- You may obtain a copy of Mulan PSL v2 at:
--          http://license.coscl.org.cn/MulanPSL2
-- THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
-- EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
-- MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
-- See the Mulan PSL v2 for more details.
]] --
local validate = require 'mc.validate'
local utils = require 'mc.utils'

local GetDevicePresence = {}

---@class FrudataIpmiCmds.GetDevicePresenceReq
---@field ManufactureId integer
---@field DeviceType integer
---@field DeviceNumber integer
---@field ReadOffset integer
---@field Length integer
local TGetDevicePresenceReq = {}
TGetDevicePresenceReq.__index = TGetDevicePresenceReq
TGetDevicePresenceReq.group = {}

local function TGetDevicePresenceReq_from_obj(obj)
    return setmetatable(obj, TGetDevicePresenceReq)
end

function TGetDevicePresenceReq.new(ManufactureId, DeviceType, DeviceNumber, ReadOffset, Length)
    return TGetDevicePresenceReq_from_obj({
        ManufactureId = ManufactureId,
        DeviceType = DeviceType,
        DeviceNumber = DeviceNumber,
        ReadOffset = ReadOffset,
        Length = Length
    })
end
---@param obj FrudataIpmiCmds.GetDevicePresenceReq
function TGetDevicePresenceReq:init_from_obj(obj)
    self.ManufactureId = obj.ManufactureId
    self.DeviceType = obj.DeviceType
    self.DeviceNumber = obj.DeviceNumber
    self.ReadOffset = obj.ReadOffset
    self.Length = obj.Length
end

function TGetDevicePresenceReq:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TGetDevicePresenceReq.group)
end

TGetDevicePresenceReq.from_obj = TGetDevicePresenceReq_from_obj

TGetDevicePresenceReq.proto_property = {'ManufactureId', 'DeviceType', 'DeviceNumber', 'ReadOffset', 'Length'}

TGetDevicePresenceReq.default = {0, 0, 0, 0, 0}

TGetDevicePresenceReq.struct = {
    {name = 'ManufactureId', is_array = false, struct = nil}, {name = 'DeviceType', is_array = false, struct = nil},
    {name = 'DeviceNumber', is_array = false, struct = nil}, {name = 'ReadOffset', is_array = false, struct = nil},
    {name = 'Length', is_array = false, struct = nil}
}

function TGetDevicePresenceReq:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'ManufactureId', self.ManufactureId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'DeviceType', self.DeviceType, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'DeviceNumber', self.DeviceNumber, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'ReadOffset', self.ReadOffset, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'Length', self.Length, 'uint8', false, errs, need_convert)

    TGetDevicePresenceReq:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TGetDevicePresenceReq.proto_property, errs, need_convert)
    return self
end

function TGetDevicePresenceReq:unpack(_)
    return self.ManufactureId, self.DeviceType, self.DeviceNumber, self.ReadOffset, self.Length
end

GetDevicePresence.GetDevicePresenceReq = TGetDevicePresenceReq

---@class FrudataIpmiCmds.GetDevicePresenceRsp
---@field CompletionCode integer
---@field ManufactureId integer
---@field EndOfList integer
---@field Data string
local TGetDevicePresenceRsp = {}
TGetDevicePresenceRsp.__index = TGetDevicePresenceRsp
TGetDevicePresenceRsp.group = {}

local function TGetDevicePresenceRsp_from_obj(obj)
    return setmetatable(obj, TGetDevicePresenceRsp)
end

function TGetDevicePresenceRsp.new(CompletionCode, ManufactureId, EndOfList, Data)
    return TGetDevicePresenceRsp_from_obj({
        CompletionCode = CompletionCode,
        ManufactureId = ManufactureId,
        EndOfList = EndOfList,
        Data = Data
    })
end
---@param obj FrudataIpmiCmds.GetDevicePresenceRsp
function TGetDevicePresenceRsp:init_from_obj(obj)
    self.CompletionCode = obj.CompletionCode
    self.ManufactureId = obj.ManufactureId
    self.EndOfList = obj.EndOfList
    self.Data = obj.Data
end

function TGetDevicePresenceRsp:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TGetDevicePresenceRsp.group)
end

TGetDevicePresenceRsp.from_obj = TGetDevicePresenceRsp_from_obj

TGetDevicePresenceRsp.proto_property = {'CompletionCode', 'ManufactureId', 'EndOfList', 'Data'}

TGetDevicePresenceRsp.default = {0, 0, 0, ''}

TGetDevicePresenceRsp.struct = {
    {name = 'CompletionCode', is_array = false, struct = nil}, {name = 'ManufactureId', is_array = false, struct = nil},
    {name = 'EndOfList', is_array = false, struct = nil}, {name = 'Data', is_array = false, struct = nil}
}

function TGetDevicePresenceRsp:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'CompletionCode', self.CompletionCode, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'ManufactureId', self.ManufactureId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'EndOfList', self.EndOfList, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'Data', self.Data, 'string', false, errs, need_convert)

    TGetDevicePresenceRsp:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TGetDevicePresenceRsp.proto_property, errs, need_convert)
    return self
end

function TGetDevicePresenceRsp:unpack(_)
    return self.CompletionCode, self.ManufactureId, self.EndOfList, self.Data
end

GetDevicePresence.GetDevicePresenceRsp = TGetDevicePresenceRsp

return GetDevicePresence
